<template>
  <div class="main p-top-60 register-artist-section" :class="{'mobile': isMobile()}">
    <a-breadcrumb v-if="!isMobile()">
      <a-breadcrumb-item>
        <router-link to="/home">Home</router-link>
      </a-breadcrumb-item>
      <a-breadcrumb-item>Artist registration</a-breadcrumb-item>
    </a-breadcrumb>
    <h2 class="sub-title">Artist registration</h2>
    <a-row :gutter="16">
      <a-col :span="24" :md="{ span: 6 }">
        <a-upload
            name="avatar"
            list-type="picture-card"
            class="avatar-uploader"
            :show-upload-list="false"
            action="https://www.mocky.io/v2/5cc8019d300000980a055e76"
            :before-upload="beforeUpload"
            @change="handleChange"
        >
          <img v-if="imageUrl" :src="imageUrl" alt="avatar"/>
          <div v-else>
            <a-icon :type="loading ? 'loading' : 'plus'"/>
            <div class="ant-upload-text">
              Upload avatar
            </div>
          </div>
        </a-upload>
      </a-col>
      <a-col :span="24" :md="{ span: 18 }">
        <a-form :form="form" :layout="formLayout" @submit="handleSubmit">
          <a-row :gutter="16">
            <a-col :span="24" :md="{ span: 12 }">
              <a-form-item label="Artist">
                <a-input placeholder="" type="text"
                         v-decorator="[
                    'name',
                    { rules: [{ required: true, message: 'Please input your name!' }] },
                  ]"
                />
              </a-form-item>
            </a-col>
            <a-col :span="24" :md="{ span: 12 }">
              <a-form-item label="Email address">
                <a-input placeholder="" type="email"
                         v-decorator="[
                    'email',
                    { rules: [{ required: true, message: 'Please input your email!' }] },
                  ]"/>
              </a-form-item>
            </a-col>
            <a-col :span="24" :md="{ span: 12 }">
              <a-form-item label="Password">
                <a-input placeholder="" type="password"
                   v-decorator="[
                    'password',
                    { rules:[
                        { required: true, message: 'Please input password!' },
                        { validator: validateToNextPassword}]
                    }]"
                  />
              </a-form-item>
            </a-col>
            <a-col :span="24" :md="{ span: 12 }">
              <a-form-item label="Confirm Password">
                <a-input placeholder="" type="password" @blur="handleConfirmBlur"
                         v-decorator="[
                    'password-confirmation',
                    { rules:[
                        { required: true, message: 'Please input password!' },
                        { validator: compareToFirstPassword}]
                    }]"
                  />
              </a-form-item>
            </a-col>
            <a-col :span="24" :md="{ span: 12 }">
              <a-form-item label="Genres">
                <a-select
                    v-decorator="[
                      'genres',
                      { rules: [{ required: true, message: 'Please select your Genres!' }] },
                    ]"
                    placeholder=""
                >
                  <a-select-option value="1">
                    Genres 1
                  </a-select-option>
                  <a-select-option value="2">
                    Genres 2
                  </a-select-option>
                  <a-select-option value="3">
                    Genres 3
                  </a-select-option>
                </a-select>
              </a-form-item>
            </a-col>
            <a-col :span="24" :md="{ span: 12 }">
              <a-form-item label="Country">
                <a-select
                    v-decorator="[
                      'country',
                      { rules: [{ required: true, message: 'Please select your country!' }] },
                    ]"
                    placeholder=""
                >
                  <a-select-option value="1">
                    Vietnamese
                  </a-select-option>
                  <a-select-option value="2">
                    Korean
                  </a-select-option>
                </a-select>
              </a-form-item>
            </a-col>
            <a-col :span="24" :md="{ span: 24 }">
              <a-form-item label="Description">
                <a-textarea>
                </a-textarea>
              </a-form-item>
            </a-col>
            <a-col :span="12">
              <a-button class="btn square-btn ant-btn-block big-btn ant-btn action-btn" @click="goBack">Cancel</a-button>
            </a-col>
            <a-col :span="12">
              <a-button class="btn square-btn ant-btn-block big-btn ant-btn action-btn" html-type="submit">Save</a-button>
            </a-col>
          </a-row>
        </a-form>
      </a-col>
    </a-row>
  </div>
</template>

<script>
function getBase64(img, callback) {
  const reader = new FileReader();
  reader.addEventListener('load', () => callback(reader.result));
  reader.readAsDataURL(img);
}

export default {
  data() {
    return {
      loading: false,
      imageUrl: '',
      formLayout: 'vertical',
      form: this.$form.createForm(this, {name: 'coordinated'}),
      confirmDirty: false,
    };
  },
  methods: {
    isMobile() {
      if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        return true;
      } else {
        return false;
      }
    },
    handleChange(info) {
      this.loading = true
      if (info.file.status === 'uploading') {
        return;
      }
      if (info.file.status === 'done') {
        // Get this url from response in real world.
        getBase64(info.file.originFileObj, imageUrl => {
          this.imageUrl = imageUrl;
          this.loading = false;
        });
        return;
      }
      if (info.file.status === 'error') {
        getBase64(info.file.originFileObj, imageUrl => {
          this.imageUrl = imageUrl;
          this.loading = false;
        });
        return;
      }
    },
    beforeUpload(file) {
      const isJpgOrPng = file.type === 'image/jpeg' || file.type === 'image/png';
      if (!isJpgOrPng) {
        this.$message.error('You can only upload JPG file!');
      }
      const isLt2M = file.size / 1024 / 1024 < 2;
      if (!isLt2M) {
        this.$message.error('Image must smaller than 2MB!');
      }
      return isJpgOrPng && isLt2M;
    },
    handleSubmit(e) {
      e.preventDefault();
      this.form.validateFields((err, values) => {
        if (!err) {
          console.log('Received values of form: ', values);
        }
      });
    },
    handleConfirmBlur(e) {
      const value = e.target.value;
      this.confirmDirty = this.confirmDirty || !!value;
    },
    compareToFirstPassword(rule, value, callback) {
      const form = this.form;
      if (value && value !== form.getFieldValue('password')) {
        callback('Two passwords that you enter is inconsistent!');
      } else {
        callback();
      }
    },
    validateToNextPassword(rule, value, callback) {
      const form = this.form;
      if (value && this.confirmDirty) {
        form.validateFields(['confirm'], {force: true});
      }
      callback();
    },
    goBack() {
      this.$router.back();
    }
  },
}
</script>

<style scoped>
.avatar-uploader > .ant-upload {
  width: 128px;
  height: 128px;
}

.ant-upload-select-picture-card i {
  font-size: 32px;
  color: #999;
}

.ant-upload-select-picture-card .ant-upload-text {
  margin-top: 8px;
  color: #666;
}

img {
  max-width: 100%;
}

/deep/ .ant-upload {
  width: 100% !important;
  max-width: 320px;
  min-height: 200px;
}
.action-btn {
  background: #1db954;
  border-radius: 30px !important;
  border: none;
}

/* Mobile Style */
.mobile {
  padding-top: 0;
  padding-bottom: 50px;
}
.mobile .sub-title {
  font-size: 16px;
  text-align: center;
  letter-spacing: -0.24px;
  color: #F1F1F1;
  font-weight: normal;
  text-align: left;
  margin-bottom: 20px;
}
.mobile .avatar-uploader {
  margin-bottom: 24px;
}
.mobile .avatar-uploader >>> .ant-upload {
  margin: 0;
  height: 100%;
  max-width: 100%;
}
</style>